## get or relative to a chosen type
process.coeff.simu<-function(data.file, z.file, alpha.file, beta.file, M1, M2, 
          everyN)
{
    myseq<-seq(from=M1, to=M2, by=everyN)
    z.mat<-as.matrix(read.table(z.file))[myseq,]
    alpha.mat<-as.matrix(read.table(alpha.file))[myseq,]
    beta.mat<-as.matrix(read.table(beta.file))[myseq,]
    alpha.alloc<-z.mat
    beta.alloc<-z.mat
    nclus<-dim(beta.mat)[2]
  
    mydata<-read.table(data.file)

    group.id<-mydata[,3]+1
  #  wt.vec<-as.vector(table(group.id))
  #  wt.vec<-wt.vec/sum(wt.vec)

    myfun.1<-function(x,y, n.clust)
    {
       z<-x
       for (i in 1:n.clust)
       {   
         z[x==(i-1)]<-y[i]
       }
       z
     }
     n.r<-dim(z.mat)[1] 

    for (i in 1:n.r)
    {
      alpha.alloc[i,]<-myfun.1(z.mat[i,], alpha.mat[i,], nclus)
      beta.alloc[i,]<-myfun.1(z.mat[i,], beta.mat[i,], nclus)
    }

 
    
    alpha.med<-apply(alpha.alloc, 2, median)
    beta.med<-apply(beta.alloc, 2, median)
    alpha.mean<-apply(alpha.alloc, 2, mean)
    beta.mean<-apply(beta.alloc, 2, mean)
    alpha.var<-apply(alpha.alloc, 2, var)
    beta.var<-apply(beta.alloc, 2, var)

    myfun.2<-function(my.x, my.p)
    {
       as.numeric(quantile(my.x, my.p))
    }

    beta.25<-apply(beta.alloc, 2, myfun.2, my.p=0.25)
    beta.75<-apply(beta.alloc, 2, myfun.2, my.p=0.75)
    
    alpha.25<-apply(alpha.alloc, 2, myfun.2, my.p=0.25)
    alpha.75<-apply(alpha.alloc, 2, myfun.2, my.p=0.75)
    
    alpha.med<-alpha.med[group.id]
    beta.med<-beta.med[group.id]
    alpha.mean<-alpha.mean[group.id]
    beta.mean<-beta.mean[group.id]
  
    alpha.25<-alpha.25[group.id]
    alpha.75<-alpha.75[group.id]

    beta.25<-beta.25[group.id]
    beta.75<-beta.75[group.id]

    alpha.var<-alpha.var[group.id]
    beta.var<-beta.var[group.id]
  
   list(alpha.mean=alpha.mean, beta.mean=beta.mean, 
        alpha.median=alpha.med, beta.median=beta.med,
        alpha.25=alpha.25, alpha.75=alpha.75,
        beta.25=beta.25, beta.75=beta.75,
        alpha.var=alpha.var, beta.var=beta.var)
}



process.coeff.id<-function(data.file, z.file, alpha.file, beta.file, M1, M2, 
          everyN, assign.vec, geno.id)
{
    myseq<-seq(from=M1, to=M2, by=everyN)
    z.mat<-as.matrix(read.table(z.file))[myseq,]
    alpha.mat<-as.matrix(read.table(alpha.file))[myseq,]
    beta.mat<-as.matrix(read.table(beta.file))[myseq,]
    alpha.alloc<-z.mat
    beta.alloc<-z.mat
    nclus<-dim(beta.mat)[2]
    n.assign.grp<-length(unique(assign.vec))

    mydata<-read.table(data.file)

    group.id<-mydata[,3]+1
  #  wt.vec<-as.vector(table(group.id))
  #  wt.vec<-wt.vec/sum(wt.vec)

    myfun.1<-function(x,y, n.clust)
    {
       z<-x
       for (i in 1:n.clust)
       {   
         z[x==(i-1)]<-y[i]
       }
       z
     }
     n.r<-dim(z.mat)[1] 

    for (i in 1:n.r)
    {
      alpha.alloc[i,]<-myfun.1(z.mat[i,], alpha.mat[i,], nclus)
      beta.alloc[i,]<-myfun.1(z.mat[i,], beta.mat[i,], nclus)
    }

 #   alpha.med<-apply(alpha.alloc, 1, weightedMedian, w=wt.vec)
 #   beta.med<-apply(beta.alloc, 1, weightedMedian, w=wt.vec)

 #   alpha.mean<-apply(alpha.alloc, 1, weighted.mean, w=wt.vec)
 #   beta.mean<-apply(beta.alloc, 1, weighted.mean, w=wt.vec)
    
    alpha.med<-apply(exp(alpha.alloc), 2, median)
    beta.med<-apply(exp(beta.alloc), 2, median)
    alpha.mean<-apply(exp(alpha.alloc), 2, mean)
    beta.mean<-apply(exp(beta.alloc), 2, mean)

    ## find the samllest median of alpha
    id.min.med<-geno.id
    
    my.alpha.med<-alpha.alloc[, id.min.med]
    alpha.adj.med.alloc<-sweep(x=alpha.alloc, MARGIN=1, STATS=my.alpha.med, FUN="-")
    alpha.adj.med.mean<-apply(exp(alpha.adj.med.alloc), 2, mean)
    alpha.adj.med.med<-apply(exp(alpha.adj.med.alloc), 2, median)

    ## find the samllest mean of alpha
    aa<-sort(alpha.mean, index.return=T)$ix
    bb<-sort(beta.mean, index.return=T)$ix
    
    id.min.mean<-aa[1]
    
    my.alpha.mean<-alpha.alloc[, id.min.mean]
    alpha.adj.mean.alloc<-sweep(x=alpha.alloc, MARGIN=1, STATS=my.alpha.mean, FUN="-")
    alpha.adj.mean.mean<-apply(exp(alpha.adj.mean.alloc), 2, mean)
    alpha.adj.mean.med<-apply(exp(alpha.adj.mean.alloc), 2, median)

    
    alpha.med<-alpha.med[group.id]
    beta.med<-beta.med[group.id]
    alpha.mean<-alpha.mean[group.id]
    beta.mean<-beta.mean[group.id]
    alpha.adj.med.mean<-alpha.adj.med.mean[group.id]
    alpha.adj.med.med<-alpha.adj.med.med[group.id]    
    alpha.adj.mean.mean<-alpha.adj.mean.mean[group.id]
    alpha.adj.mean.med<-alpha.adj.mean.med[group.id]  


    list(alpha.mean=alpha.mean, beta.mean=beta.mean, 
        alpha.median=alpha.med, beta.median=beta.med,
        alpha.adj.med.median=alpha.adj.med.med, alpha.adj.med.mean=alpha.adj.med.mean,
        alpha.adj.mean.median=alpha.adj.mean.med, alpha.adj.mean.mean=alpha.adj.mean.mean)
}


process.coeff<-function(data.file, z.file, alpha.file, beta.file, M1, M2, 
          everyN, assign.vec)
{
    myseq<-seq(from=M1, to=M2, by=everyN)
    z.mat<-as.matrix(read.table(z.file))[myseq,]
    alpha.mat<-as.matrix(read.table(alpha.file))[myseq,]
    beta.mat<-as.matrix(read.table(beta.file))[myseq,]
    alpha.alloc<-z.mat
    beta.alloc<-z.mat
    nclus<-dim(beta.mat)[2]
    n.assign.grp<-length(unique(assign.vec))

    mydata<-read.table(data.file)

    group.id<-mydata[,3]+1
  #  wt.vec<-as.vector(table(group.id))
  #  wt.vec<-wt.vec/sum(wt.vec)

    myfun.1<-function(x,y, n.clust)
    {
       z<-x
       for (i in 1:n.clust)
       {   
         z[x==(i-1)]<-y[i]
       }
       z
     }
     n.r<-dim(z.mat)[1] 

    for (i in 1:n.r)
    {
      alpha.alloc[i,]<-myfun.1(z.mat[i,], alpha.mat[i,], nclus)
      beta.alloc[i,]<-myfun.1(z.mat[i,], beta.mat[i,], nclus)
    }

 #   alpha.med<-apply(alpha.alloc, 1, weightedMedian, w=wt.vec)
 #   beta.med<-apply(beta.alloc, 1, weightedMedian, w=wt.vec)

 #   alpha.mean<-apply(alpha.alloc, 1, weighted.mean, w=wt.vec)
 #   beta.mean<-apply(beta.alloc, 1, weighted.mean, w=wt.vec)
    
    alpha.med<-apply(exp(alpha.alloc), 2, median)
    beta.med<-apply(exp(beta.alloc), 2, median)
    alpha.mean<-apply(exp(alpha.alloc), 2, mean)
    beta.mean<-apply(exp(beta.alloc), 2, mean)

    ## find the samllest median of alpha
    id.min.med<-sort(alpha.med, index.return=T)$ix[1]
    
    my.alpha.med<-alpha.alloc[, id.min.med]
    alpha.adj.med.alloc<-sweep(x=alpha.alloc, MARGIN=1, STATS=my.alpha.med, FUN="-")
    alpha.adj.med.mean<-apply(exp(alpha.adj.med.alloc), 2, mean)
    alpha.adj.med.med<-apply(exp(alpha.adj.med.alloc), 2, median)

    ## find the samllest mean of alpha
    id.min.mean<-sort(alpha.mean, index.return=T)$ix[1]
    
    my.alpha.mean<-alpha.alloc[, id.min.mean]
    alpha.adj.mean.alloc<-sweep(x=alpha.alloc, MARGIN=1, STATS=my.alpha.mean, FUN="-")
    alpha.adj.mean.mean<-apply(exp(alpha.adj.mean.alloc), 2, mean)
    alpha.adj.mean.med<-apply(exp(alpha.adj.mean.alloc), 2, median)

    
    alpha.med<-alpha.med[group.id]
    beta.med<-beta.med[group.id]
    alpha.mean<-alpha.mean[group.id]
    beta.mean<-beta.mean[group.id]
    alpha.adj.med.mean<-alpha.adj.med.mean[group.id]
    alpha.adj.med.med<-alpha.adj.med.med[group.id]    
    alpha.adj.mean.mean<-alpha.adj.mean.mean[group.id]
    alpha.adj.mean.med<-alpha.adj.mean.med[group.id]  


    list(alpha.mean=alpha.mean, beta.mean=beta.mean, 
        alpha.median=alpha.med, beta.median=beta.med,
        alpha.adj.med.median=alpha.adj.med.med, alpha.adj.med.mean=alpha.adj.med.mean,
        alpha.adj.mean.median=alpha.adj.mean.med, alpha.adj.mean.mean=alpha.adj.mean.mean)
}

process.coeff.old<-function(data.file, z.file, alpha.file, beta.file, M1, M2, 
          everyN, assign.vec)
{
    myseq<-seq(from=M1, to=M2, by=everyN)
    z.mat<-as.matrix(read.table(z.file))[myseq,]
    alpha.mat<-as.matrix(read.table(alpha.file))[myseq,]
    beta.mat<-as.matrix(read.table(beta.file))[myseq,]
    alpha.alloc<-z.mat
    beta.alloc<-z.mat
    nclus<-dim(beta.mat)[2]
    n.assign.grp<-length(unique(assign.vec))

    mydata<-read.table(data.file)

    group.id<-mydata[,3]+1
  #  wt.vec<-as.vector(table(group.id))
  #  wt.vec<-wt.vec/sum(wt.vec)

    myfun.1<-function(x,y, n.clust)
    {
       z<-x
       for (i in 1:n.clust)
       {   
         z[x==(i-1)]<-y[i]
       }
       z
     }
     n.r<-dim(z.mat)[1] 

    for (i in 1:n.r)
    {
      alpha.alloc[i,]<-myfun.1(z.mat[i,], alpha.mat[i,], nclus)
      beta.alloc[i,]<-myfun.1(z.mat[i,], beta.mat[i,], nclus)
    }

 #   alpha.med<-apply(alpha.alloc, 1, weightedMedian, w=wt.vec)
 #   beta.med<-apply(beta.alloc, 1, weightedMedian, w=wt.vec)

 #   alpha.mean<-apply(alpha.alloc, 1, weighted.mean, w=wt.vec)
 #   beta.mean<-apply(beta.alloc, 1, weighted.mean, w=wt.vec)
    
    alpha.med<-apply(exp(alpha.alloc), 2, median)
    beta.med<-apply(exp(beta.alloc), 2, median)
    alpha.mean<-apply(exp(alpha.alloc), 2, mean)
    beta.mean<-apply(exp(beta.alloc), 2, mean)
    
    alpha.med<-alpha.med[group.id]
    beta.med<-beta.med[group.id]
    alpha.mean<-alpha.mean[group.id]
    beta.mean<-beta.mean[group.id]
    
    list(alpha.mean=alpha.mean, beta.mean=beta.mean, 
        alpha.median=alpha.med, beta.median=beta.med)
}


## have covariates: n.col is the number of columns in data.file
postProcess <- function(data.file, z.file, psi.file, alpha.file, beta.file, dev.file,
             tao.file, nclus,  M1=1, M2=Inf, so.file=NULL, everyN=1) {

  # Load the shared library
  if (!is.null(so.file)) dyn.load(so.file)

  # Get the group ids (column 3 in the data file)
  temp <- read.table(data.file)
  n.col<-dim(temp)[2]
  nsub <- nrow(temp)
  grp_id <- temp[, 3]
  outcome.vec<-temp[,1]
  geno.vec<-temp[,2]
  
  ## the remaining are covariates
  n.cov <-n.col - 3
  if (n.cov > 0)
  {
    cov.mat<-temp[, 4:n.col]
  }
  # Get the number of groups and clusters 
  temp <- scan(z.file, what=integer(0), sep=" ", nlines=1)
  ngrp <- length(temp)
  

  dev.vec<-scan(dev.file, what=double(0), sep="\n")

  # Read in psi and get the number of iterations
  psi  <- scan(psi.file, what=double(0), sep="\n")
  niter <- length(psi)
  
  if (M2 > niter) M2 <- niter
  if (M1 < 1) M1 <- 1

  # Get the rows to use
  use.rows <- seq(from=M1+everyN-1, to=M2, by=everyN)

  psi <- psi[use.rows]
  mean.dev <-mean(dev.vec[use.rows])
  median.dev<-median(dev.vec[use.rows])

  # Get the Z matrix
  nsub <- as.integer(nsub)
  niter <- as.integer(niter)
  M1 <- as.integer(M1)
  M2 <- as.integer(M2)
  ngrp <- as.integer(ngrp)
  nclus <- as.integer(nclus)
  Dmat <- integer(ngrp*ngrp)
  grp_id <- as.integer(grp_id)
  everyN <- as.integer(everyN)

  temp <- .C("get_Z", M1, M2, everyN, niter, ngrp, z.file,  Dmat=Dmat)

  # Convert vectors to matrices 
  Dmat <- temp$Dmat
  dim(Dmat) <- c(ngrp, ngrp)

  rm(temp)
  gc()

  # Get the median of alpha and beta for each subject
  alpha <- double(nsub)
  beta  <- double(nsub)
  temp <- .C("median_alpha_beta", M1, M2, everyN, nsub, niter, nclus, ngrp, z.file, grp_id, alpha.file, beta.file, alpha=alpha, beta=beta)

  alpha.median <- temp$alpha
  beta.median  <- temp$beta


  # Get the mean of alpha and beta for each subject
  alpha <- double(nsub)
  beta  <- double(nsub)
  temp <- .C("get_alpha_beta", M1, M2, everyN, nsub, niter, nclus, ngrp, z.file, grp_id, alpha.file, beta.file, alpha=alpha, beta=beta)

  alpha.mean <- temp$alpha
  beta.mean  <- temp$beta
  
  offset.mean<-rep(0, nsub)
  offset.median<-offset.mean
  if (n.cov > 0)
  {    
    cov.mat<-as.matrix(cov.mat, ncol=n.cov) 
    tao.mat<-read.table(tao.file) 
    tao.mat<-as.matrix(tao.mat[use.rows,], ncol=n.cov)
    tao.mean<-apply(tao.mat, 2, mean)
    tao.mean<-as.matrix(tao.mean, ncol=1)
    offset.mean<-as.numeric(cov.mat %*% tao.mean)
 
    tao.median<-apply(tao.mat, 2, median)
    tao.median<-as.matrix(tao.median, ncol=1)
    offset.median<-as.numeric(cov.mat %*% tao.median)
  } 

  
  dev.mean <-getDev(outcome.vec, geno.vec, alpha.mean, beta.mean, offset.mean)
  dev.median <-getDev(outcome.vec, geno.vec, alpha.median, beta.median, 
           offset.median)

  rm(temp)
  gc()

  list(psi=psi, sim.mat=Dmat, alpha.mean=alpha.mean, beta.mean=beta.mean,
    dev.mean=dev.mean,
   mean.dev=mean.dev, dev.median=dev.median, median.dev=median.dev,
alpha.median=alpha.median, beta.median=beta.median, M2=M2)

} 

# Function to compute the new cluster assignments
newClustering <- function(dis.mat, z.file, alpha.file, beta.file, so.file=NULL, 
                          out.alpha="alpha.txt", out.beta="beta.txt", out.z="z.txt",
                          nclus, M1=1, M2=Inf, everyN=1) {

  # Load the shared library
  if (!is.null(so.file)) dyn.load(so.file)

  if (M1 < 1) M1 <- 1
  if (!is.finite(M2)) M2 <- 1e8

  temp  <- scan(z.file, what=integer(0), sep=" ", nlines=1)
  ngrp  <- length(temp)
  

  # Cal the pam function to do the clustering on the similarity matrix
  #temp       <- pam(dis.mat, nclus)
  assign.vec <- temp$clustering
  
  rm(dis.mat, temp)
  gc()

  # Get all permutations of the clusters (permn function in combinat package)
  #all.perm <- permn(nclus)
  nperm    <- as.integer(length(all.perm))
  all.perm <- as.integer(unlist(all.perm) - 1) # First nclus elements are the first permutation
  
  # Subtract 1 befrore calling the C function
  assign.vec <- as.integer(assign.vec - 1)
  nties <- integer(1)

  temp <- .C("new_clustering", as.integer(M1), as.integer(M2), as.integer(everyN), 
              assign.vec, as.integer(nclus), as.integer(ngrp), 
              z.file, alpha.file, beta.file, out.alpha, out.beta, out.z, 
              all.perm, nperm, nties=nties)
  
  list(n.ties=temp$nties) 

} # END: newClustering

# function to get the -2.0 logLikehood
getDev<-function(outcome.vec, geno.vec, alpha, beta, offset)
{
   a<-(1-outcome.vec) / (1.0 + exp(alpha + geno.vec * beta + offset)) + 
           outcome.vec * exp(alpha + geno.vec * beta + offset) / 
          (1.0 + exp(alpha + geno.vec * beta + offset))
   sum(log(a)) * (-2.0)
}

## simi.mat is the simialrity matrix
## pc.mat is the matrix of eigenvectors
## ev.vec is the correponding eigen-value

eigen.to.dis<-function(eigen.mat, eval.vec)
{
  n.eigen<-length(eval.vec)
  eigen.mat<-as.matrix(eigen.mat)
  e.mat<-diag(sqrt(eval.vec))
  new.mat<-eigen.mat %*% e.mat
  as.matrix(dist(new.mat))
}

sim.to.dis<-function(sim.mat)
{
  n<-dim(sim.mat)[1]
  v.diag<-diag(sim.mat)
  i.mat<-matrix(v.diag, byrow=F, ncol=n, nrow=n)
  dis.mat<-sqrt(i.mat + t(i.mat) - 2*sim.mat)
  dis.mat
}
   
## program to find the neighorhood given the cut.val
find.NB.scale<-function(dist.mat, cut.val)
{
   n.subj<-dim(dist.mat)[1]
   NB.mat<-matrix(0, ncol=n.subj, nrow=n.subj)
   NB.mat[dist.mat <cut.val]<-1
   diag(NB.mat)<-0
   NB.mat
}


## program to use rank
## method.tie is "min", "max" or "a
find.NB.rank<-function(dist.mat, rank.cut, method.tie)
{
    rank.mat<-apply(dist.mat, 2, rank, ties.method=method.tie)
    NB.mat<-rank.mat    
    NB.mat[rank.mat<=rank.cut]<-1
    NB.mat[rank.mat>rank.cut]<-0
    NB.mat<-(NB.mat + t(NB.mat))/2
    diag(NB.mat)<-0
    NB.mat

}   

find.NB.rank.2<-function(dist.mat, rank.cut)
{
    rank.mat<-apply(dist.mat, 2, rank, ties.method="min")
    NB.mat<-rank.mat    
    NB.mat[rank.mat<=rank.cut]<-1
    NB.mat[rank.mat>rank.cut]<-0
    NB.mat<-(NB.mat + t(NB.mat))/2
    diag(NB.mat)<-0
    NB.mat[NB.mat >0]<-1
    NB.mat
}   

simu.fun<-function(f, beta, pheno)
{
   w.vec<-exp(c(0, beta, 2*beta))      
   f.cn.vec<-c((1-f)^2, 2*f*(1-f), f*f)
   f.ca.vec<-f.cn.vec * w.vec
   f.ca.vec<-f.ca.vec / sum(f.ca.vec)
   n.ca<-sum(pheno==1)
   n.cn<-sum(pheno==0)
   geno.out<-pheno   
   geno.out[pheno==1]<-sample(x=c(0,1,2),size=n.ca, replace=T,  prob= f.ca.vec)
   geno.out[pheno==0]<-sample(x=c(0,1,2),size=n.cn, replace=T,  prob= f.cn.vec) 
   geno.out
}



gen.group.id <- function(outcome.vec, dist.mat) {
  # outcome.vec     Vector of 0 (controls) and 1 (cases) 
  # dist.mat        Distance matrix for all subjects in the same
  #                 order as outcome.vec
  
  n <- length(outcome.vec)
  case.ids <- (1:n)[(outcome.vec == 1)]
  if (!length(case.ids)) stop("ERROR: no cases")
  group <- integer(n)
  index <- 0

  # Loop over each subject
  for (i in 1:n) {
    cc <- outcome.vec[i]
    if (cc == 1) {
      # Case 
      if (!group[i]) {
        # Group has not been assigned yet
        group[i] <- index
        index <- index + 1
      }
    } else {
      # Control
      dvec <- dist.mat[case.ids, i]

      # Find the minimum distance. Watch out for ties
      minj <- which.min(dvec)
      mind <- dvec[minj]
      temp <- (dvec <= dvec[minj])
      if (sum(temp) > 1) {
        case <- sample(case.ids[temp], 1)
      } else {
        case <- case.ids[minj]
      }

      # Assign the group
      grp <- group[case]
      if (!grp) {
        grp <- index
        index <- index + 1
        group[case] <- grp
      }
      group[i] <- grp     
    }        
  }

  group

}

gen.sim.matrix <- function(k) {

  # Function to get the position in the vector from the (x, y) coordinate
  position <- function(x, y) {
    return(y + (x-1)*k)
  }

  # Function to get the x-coordinate
  grid.x <- function(m) {
    return(ceiling(m/k))
  }

  # Function to get the y-coordinate
  grid.y <- function(m, x) {
    return(m - (x - 1)*k)
  }

  # Function to return the neighbors
  neighbors <- function(x, y) {
    xvec <- c(x-1, x+1, x,   x)
    yvec <- c(y,   y,   y-1, y+1)
    temp <- (xvec > 0) & (xvec <= k) & (yvec > 0) & (yvec <= k)

    list(x=xvec[temp], y=yvec[temp])
  }

  n   <- k*k
  sim <- matrix(data=0, nrow=n, ncol=n)

  for (i in 1:n) {

    # Get the grid point of subject i
    x <- grid.x(i)
    y <- grid.y(i, x)

    # Get the neighbors
    temp <- neighbors(x, y)
    xvec <- temp$x
    yvec <- temp$y

    # Get the positions of these neighbors
    for (j in 1:length(xvec)) {
      pos <- position(xvec[j], yvec[j])
      sim[i, pos] <- 1
    }

  }

  return(sim)

}




gen.group.clust <- function(outcome.vec, dist.mat, nclus) 
{
  # outcome.vec     Vector of 0 (controls) and 1 (cases) 
  # dist.mat        Distance matrix for all subjects in the same
  #                 order as outcome.vec
  
	## do cluster for cases
	
  n <- length(outcome.vec)
  case.ids <- c(1:n)[outcome.vec == 1]
  control.ids <-c(1:n)[outcome.vec == 0]
  n.control <-length(control.ids)
	
  dist.mat.ca<-dist.mat[case.ids, case.ids]
  
  #temp       <- pam(dist.mat.ca, nclus)
  assign.ca.vec <- temp$clustering
  assign.cn.vec <-rep(-9, n.control)
 
  t.1<-temp$id.med
  center.id <-case.ids[t.1]
  grp.label <-c(1:length(center.id))

  ## loop over controls to assign controls to case group

  for (i in 1:n.control)
  {
      dvec <-dist.mat[control.ids[i], center.id]
      minj <- which.min(dvec)
      mind <- dvec[minj]
      temp <- (dvec <= dvec[minj])	
  
      if (sum(temp) > 1) 
      {
	## this is important, as sample(7,1) is to sample from (1:7)
        grp.chosen <- sample(grp.label[temp], 1)
      } else {
        grp.chosen <- grp.label[minj]
      }

      assign.cn.vec[i] <-grp.chosen
  }

  grp.id <-rep(-9, n)
  grp.id[case.ids] <-assign.ca.vec
  grp.id[control.ids] <- assign.cn.vec
	
  list(clustering=grp.id, id.med=center.id) 

}

region.assign<-function(assign.vec, scale.vec)
{
  ## region 1, x2>=x1
  ## region 2, x2 < x1

  n.r1<-sum(assign.vec==1)
  n.r2<-sum(assign.vec==2)
  n.sample<-length(assign.vec)

  n.try<-5*(n.r1 + n.r2)
  
  t1.vec<-runif(n.try)
  t2.vec<-runif(n.try)

  r.vec<-rep(-1, n.try)
  r.vec[t1.vec<=t2.vec]<-1
  r.vec[t1.vec>t2.vec]<-2


  id.vec<-c(1:n.try)
  id.vec.1<-id.vec[r.vec==1]
  id.vec.2<-id.vec[r.vec==2]

  if (length(id.vec.1) < n.r1 || length(id.vec.2) < n.r2)
  {
    stop("not enogh try")
  }


  id.vec.1<-id.vec.1[1:n.r1]
  id.vec.2<-id.vec.2[1:n.r2]
   
  
  x1.vec<-rep(-1, n.sample)
  x2.vec<-x1.vec

  x1.vec[assign.vec==1]<-t1.vec[id.vec.1]
  x2.vec[assign.vec==1]<-t2.vec[id.vec.1]

  x1.vec[assign.vec==2]<-t1.vec[id.vec.2]
  x2.vec[assign.vec==2]<-t2.vec[id.vec.2]
  
  num.noise<-length(scale.vec)-2
  if (num.noise > 0)
  {
   noise.mat<-runif(num.noise*n.sample)
   noise.mat<-matrix(noise.mat, ncol=num.noise, nrow=n.sample)
   x.mat<-cbind(x1.vec, x2.vec, noise.mat)
  }
  if (num.noise == 0)
  {
    x.mat<-cbind(x1.vec, x2.vec)
  }

  dist.mat<-eigen.to.dis(x.mat, scale.vec)
  
  list(dist.mat=dist.mat, latent.mat=x.mat)
}


define.NB.geno<-function(geno.mat, num.neighbor=4, method.tie="min")
{
   ## first find the number of differnt type

   rank.cut<-num.neighbor + 1  
   geno.mat.scale<-scale(geno.mat)
   geno.mat <- apply(geno.mat, 1, paste, collapse="", sep="")
   geno.unique<-unique(geno.mat)
   geno.unique.scale<-unique(geno.mat.scale)

   #num.unique<-dim(geno.unique)[1]
   #num.subj<-dim(geno.mat)[1]
   num.unique  <- length(geno.unique)
   num.subj    <- length(geno.mat)

   grp.subj<-rep(-9, num.subj) 
  
   #ck.vec.fun<-function(x, ref.vec)
   #{
   #   all(x==ref.vec)
   #}

   for (i in 1:num.unique)
   {
     #id.ck<-apply(geno.mat, 1, ck.vec.fun, ref.vec=geno.unique[i,])
     id.ck <- geno.mat == geno.unique[i] 
     grp.subj[id.ck]<-i
   }     

   dis.mat<-dist(x=geno.unique.scale, method="euclidean", diag=T, upper=T)
   dis.mat<-as.matrix(dis.mat)
   NB.mat<-find.NB.rank(dis.mat,rank.cut, method.tie)
   list(geno.unique=geno.unique, geno.unique.scale=geno.unique.scale,
      NB.mat=NB.mat, grp.subj=grp.subj, geno.mat.scale=geno.mat.scale)
}     
