% --- Source file: man/heatMap.Rd ---
\name{heatMap}
\alias{heatMap}
\title{Heat Map}
\description{
Create a heat map using the Krig function
}
\usage{
heatMap(x, y, z, op=NULL)
}
\arguments{
  \item{x}{Vector of x-coordinates.}
  \item{y}{Vector of y-coordinates.}
  \item{z}{Vector of surface values.}
  \item{op}{List of options. See \code{details} for all possible options.}
}
\value{
  The returned value is the Krig model fit.
}
\details{
  The heat map is produced by first calling the \code{\link[fields]{Krig}} function and then using
  the using the output from \code{\link[fields]{Krig}} 
  in the \code{\link[fields]{surface}} function.
 
 \bold{Options list:} \cr
 Below are the names for the options list \code{op}. All names have default values
         if they are not specified.
  \itemize{
  \item \code{ncolors} The number of colors used in \code{\link[grDevices]{heat.colors}}. The default is 20.
  \item \code{xlab} X-axis label. The default is "".
  \item \code{ylab} Y-axis label. The default is "".

  } % END: itemize


}

\examples{

 set.seed(123)
 n <- 100
 x <- -4 + 4*runif(n)
 y <- -4 + 4*runif(n)
 z <- rnorm(n) + x + y
 fit <- heatMap(x, y, z)

}
\seealso{\code{\link{plot_xy_hist}}}